﻿using Infragistics.Win;
using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ComboEditorHeaderClick
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UltraDataRow row;
            for (int i =1;i<=10;i++) 
            {
                row = this.ultraDataSource1.Rows.Add();
                row[0] = i;
                row[1] ="A"+ i;
                row[2] = "B"+i;

            }

            this.ultraCombo1.DataSource = ultraDataSource1;

            this.ultraCombo1.DisplayLayout.Bands[0].Header.Caption = "Add New Row";
            this.ultraCombo1.DisplayLayout.Bands[0].HeaderVisible = true;
            this.ultraCombo1.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.Select;
            this.ultraCombo1.DisplayLayout.Override.SelectTypeCol = SelectType.Default;

            this.ultraCombo1.AfterDropDown += UltraCombo1_AfterDropDown;

            this.ultraGrid1.DisplayLayout.Bands[0].Columns.Add("DropDownColumn");
            var comboBoxColumn = this.ultraGrid1.DisplayLayout.Bands[0].Columns[this.ultraGrid1.DisplayLayout.Bands[0].Columns.Count - 1];
            comboBoxColumn.EditorComponent = this.ultraCombo1;
            comboBoxColumn.ButtonDisplayStyle = Infragistics.Win.UltraWinGrid.ButtonDisplayStyle.Always;

        }

        private void UltraCombo1_AfterDropDown(object sender, EventArgs e)
        {
            this.ultraCombo1.AfterDropDown -= UltraCombo1_AfterDropDown;
            var control =  Infragistics.Win.DropDownManager.GetCurrentDropDownControl(this.ultraGrid1);
            control.MouseUp += Control_MouseUp;
        }

        private void Control_MouseUp(object sender, MouseEventArgs e)
        {
            var ultraControl = sender as IUltraControlElement;
            if (null == ultraControl)
                return;

            var mainUIElement = ultraControl.MainUIElement;
            if (null == mainUIElement)
                return;

            var clickedElement = mainUIElement.ElementFromPoint(e.Location);
            if (null == clickedElement)
                return;

            var header = clickedElement.GetContext(typeof(BandHeader)) as BandHeader;
            if (null != header)
            {
                var newRow = this.ultraDataSource1.Rows.Add();
                var comboRow = this.ultraCombo1.Rows.GetRowWithListIndex(this.ultraDataSource1.Rows.Count - 1);
                comboRow.Cells[0].Value = this.ultraDataSource1.Rows.Count;
                this.ultraCombo1.ActiveRow = comboRow;
            }
        }
    }
}
