﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinDataSource
Imports Infragistics.Win.UltraWinGrid
Imports System
Imports System.Windows.Forms

Namespace ComboEditorHeaderClick
    Public Partial Class Form1
        Inherits Form

        Public Sub New()
            InitializeComponent()
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs)
            Dim row As UltraDataRow

            For i = 1 To 10
                row = ultraDataSource1.Rows.Add()
                row(0) = i
                row(1) = "A" & i
                row(2) = "B" & i
            Next

            ultraCombo1.DataSource = ultraDataSource1
            ultraCombo1.DisplayLayout.Bands(0).Header.Caption = "Add New Row"
            ultraCombo1.DisplayLayout.Bands(0).HeaderVisible = True
            ultraCombo1.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.Select
            ultraCombo1.DisplayLayout.Override.SelectTypeCol = SelectType.Default
            AddHandler ultraCombo1.AfterDropDown, AddressOf UltraCombo1_AfterDropDown
            ultraGrid1.DisplayLayout.Bands(0).Columns.Add("DropDownColumn")
            Dim comboBoxColumn = ultraGrid1.DisplayLayout.Bands(0).Columns(ultraGrid1.DisplayLayout.Bands(0).Columns.Count - 1)
            comboBoxColumn.EditorComponent = ultraCombo1
            comboBoxColumn.ButtonDisplayStyle = UltraWinGrid.ButtonDisplayStyle.Always
        End Sub

        Private Sub UltraCombo1_AfterDropDown(ByVal sender As Object, ByVal e As EventArgs)
            RemoveHandler ultraCombo1.AfterDropDown, AddressOf UltraCombo1_AfterDropDown
            Dim control = DropDownManager.GetCurrentDropDownControl(ultraGrid1)
            AddHandler control.MouseUp, AddressOf Control_MouseUp
        End Sub

        Private Sub Control_MouseUp(ByVal sender As Object, ByVal e As MouseEventArgs)
            Dim ultraControl = TryCast(sender, IUltraControlElement)
            If Nothing Is ultraControl Then Return
            Dim mainUIElement = ultraControl.MainUIElement
            If Nothing Is mainUIElement Then Return
            Dim clickedElement = mainUIElement.ElementFromPoint(e.Location)
            If Nothing Is clickedElement Then Return
            Dim header = TryCast(clickedElement.GetContext(GetType(BandHeader)), BandHeader)

            If Nothing IsNot header Then
                Dim newRow = ultraDataSource1.Rows.Add()
                Dim comboRow = ultraCombo1.Rows.GetRowWithListIndex(ultraDataSource1.Rows.Count - 1)
                comboRow.Cells(0).Value = ultraDataSource1.Rows.Count
                ultraCombo1.ActiveRow = comboRow
            End If
        End Sub
    End Class
End Namespace
